#include<iostream>
#include<string>
#include<algorithm>
#define INF 1000000000
using namespace std;



int costD, costA, costC, N, M, dp[1001][1001];
string a, b;




int main() {
	cin >> N >> a >> M >> b >> costD >> costA >> costC;
	
	
	fill(dp[0], dp[0] + 1001 * 1001, INF);
	dp[0][0] = 0;
	
	
	//------------------------------------------------------------------
	//DP is performed here
	
	for(int i=0;i<=N;i++)
		for(int j=0;j<=M;j++) {
			
			//First deletion
			if(i < N)
				dp[i+1][j] = min(dp[i+1][j], dp[i][j] + costD);
			
			//Next insertion
			if(j < M)
				dp[i][j+1] = min(dp[i][j+1], dp[i][j] + costA);
				
			
			//Finally modify operation
			if(i < N && j < M) {
				
				if(a[i] == b[j])
					dp[i+1][j+1] = min(dp[i+1][j+1], dp[i][j]);
				else
					dp[i+1][j+1] = min(dp[i+1][j+1], dp[i][j] + costC);
				
			}
			
			
		}
	
	
	cout << dp[N][M] << '\n';
	
	return 0;
	
}
